<?php

/**
 * @copyright (c) 2020.
 * @author            Alan Fuller (support@fullworksplugins.com)
 * @licence           GPL V3 https://www.gnu.org/licenses/gpl-3.0.en.html
 * @link                  https://fullworksplugins.com
 *
 * This file is part of  a Fullworks plugin.
 *
 *   This plugin is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     This plugin is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with  this plugin.  https://www.gnu.org/licenses/gpl-3.0.en.html
 *
 *     Plugin Name: Quick Event Manager
 *
 *     Plugin URI: https://fullworksplugins.com/products/quick-event-manager/
 *     Description: A quick and easy to use Event Manager
 *     Version: 9.6.5
 *     Requires at least: 4.6
 *     Requires PHP: 5.6
 *     Author: Fullworks
 *     Author URI: https://fullworksplugins.com/
 *     Text Domain: quick-event-manager
 *     Domain Path: /languages
 *
 *     Original Author: Aerin
 *
 */
namespace Quick_Event_Manager\Plugin;

use  Quick_Event_Manager\Plugin\Control\Plugin ;
use  Quick_Event_Manager\Plugin\Control\Freemius_Config ;
// If this file is called directly, abort.
if ( !defined( 'WPINC' ) ) {
    die;
}

if ( !function_exists( 'Quick_Event_Manager\\Plugin\\run_Quick_Event_Manager' ) ) {
    define( 'QUICK_EVENT_MANAGER_PLUGIN_DIR', trailingslashit( plugin_dir_path( __FILE__ ) ) );
    define( 'QUICK_EVENT_MANAGER_PLUGIN_FILE', plugin_basename( __FILE__ ) );
    define( 'QUICK_EVENT_MANAGER_PLUGIN_NAME', 'quick-event-manager' );
    // Include the autoloaders so we can dynamically include the classes.
    require_once QUICK_EVENT_MANAGER_PLUGIN_DIR . 'control/autoloader.php';
    require_once QUICK_EVENT_MANAGER_PLUGIN_DIR . 'vendor/autoload.php';
    function run_Quick_Event_Manager()
    {
        $freemius = new Freemius_Config();
        $freemius = $freemius->init();
        // Signal that SDK was initiated.
        do_action( 'quick_event_manager_fs_loaded' );
        register_activation_hook( __FILE__, array( '\\Quick_Event_Manager\\Plugin\\Control\\Activator', 'activate' ) );
        register_deactivation_hook( __FILE__, array( '\\Quick_Event_Manager\\Plugin\\Control\\Deactivator', 'deactivate' ) );
        /**
         * @var \Freemius $freemius freemius SDK.
         */
        $freemius->add_action( 'after_uninstall', array( '\\Quick_Event_Manager\\Plugin\\Control\\Uninstall', 'uninstall' ) );
        $plugin = new Plugin( 'quick-event-manager', '9.6.5', $freemius );
        $plugin->run();
    }
    
    run_Quick_Event_Manager();
} else {
    die( esc_html__( 'Cannot execute as the plugin already exists, if you have a free version installed deactivate that and try again', 'quick-event-manager' ) );
}
